###单因素COX
rm(list = ls()) ## 清空环境变量
setwd("D:/LUAD/LUAD_M6A")
getwd()
# load("D:/LU/data")
load("./data/GSE72094.Rdata")
GSE72094[1:7,1:6]
library(rms) ## 加载R包
library(ResourceSelection)
library(dplyr)
library(caret)
library(tidyverse)
library(ggpubr)
library(plyr)

# 
#{
# library(org.Hs.eg.db)
# k=keys(org.Hs.eg.db,keytype = "ENSEMBL")
# list=select(org.Hs.eg.db,keys=k,columns = c("ENTREZID","SYMBOL"), keytype="ENSEMBL")
# ID <- read.csv("D:/LU/特殊基因集/Pyroptosis/Pyroptosos.csv")
# ID_list=list[match(ID$ENSEMBL,list[,"ENSEMBL"]),]
# write.csv(ID_list,"D:/LU/特殊基因集/Pyroptosis/Pyroptosos_output.csv")

# 额外处理，TCGAOS数据类型不对
# rownames(GSE72094) <- GSE72094[,1]
# GSE72094[1:7,1:6]
# GSE72094 <- GSE72094[,-1]
# GSE72094_clinic <- GSE72094[,1:2]
# colnames(GSE72094_clinic) <- c("OS_status","OS_time")
# str(GSE72094_clinic)
# GSE72094_clinic <- as.data.frame(lapply(GSE72094_clinic,as.numeric))
# ##
# GSE72094_exp <- GSE72094[,-c(1:2)]
# GSE72094_exp <- GSE72094_exp[,colSums(GSE72094_exp>0) > nrow(GSE72094_exp)/2]
# GSE72094_exp[1:7,1:6]
# GSE72094 <- cbind(GSE72094_clinic,GSE72094_exp)
# GSE72094 <- GSE72094[GSE72094$OS_time>30,]

# save(GSE72094,file = 'GSE72094.RData')



# str(GSE72094)
df <- GSE72094
BaSurv <- Surv(time = df$OS_time, ## 生存时间
               event = df$OS_status) ## 生存状态

UniCox <- function(x){ ## 构建一个R function 便于后期调用
  FML <- as.formula(paste0('BaSurv~',x)) ## 构建生存分析公式
  GCox <- coxph(FML, data = df) ## Cox分析
  GSum <- summary(GCox) ## 输出结果
  HR <- GSum$coefficients[,2] ## 输出HR值
  PValue <- GSum$coefficients[,5] ## 输出P值
  CI <- paste0(GSum$conf.int[,3:4],collapse = "-") ## 输出HR的执行区间
  coef <- GSum$coefficients[,1] %>% as.numeric()
  Unicox <- data.frame("characteristics" = x, ## 返回结果，并构建数据框
                       "coef" = coef,
                       "Hazard Ratio" = HR,
                       "CI95" = CI,
                       "P Value" = PValue)
  return(Unicox)
}

VarNames <- colnames(df)[-c(1,2)]## 输出需要分析的变量名字

UniVar <- lapply(VarNames,UniCox) ## 批量做Cox分析
UniVar <- ldply(UniVar,data.frame) ## 将结果整理为一个数据框 
dir.create("./results")
dir.create("./results/1-单因素cox")
save(UniVar,file = "./results/1-单因素cox/UniVar.Rdata")
load("./results/1-单因素cox/UniVar.Rdata")
#按照p=0.05筛选，可以自行调整筛选值
UniVar_0.05 <- UniVar$characteristics[which(UniVar$P.Value < 0.05)] %>% as.character()
write.csv(UniVar_0.05,file = "./results/1-单因素cox/UniVar_0.05.csv",row.names=F)
save(UniVar_0.05,file = "./results/1-单因素cox/UniVar_0.05.Rdata")
load(file = "./results/1-单因素cox/UniVar.Rdata")

#p<0.2作为备选————改成0.1
UniVar_0.2 <- UniVar$characteristics[which(UniVar$P.Value < 0.2)] %>% as.character()
save(UniVar_0.2,file = "./results/1-单因素cox/UniVar_0.2.Rdata")


library(survival)
library(survminer)
rm(list = ls()) ## 清空环境变量
setwd("D:/LUAD/LUAD_M6A")
getwd()
load("./data/GSE72094.Rdata")
GSE72094[1:7,1:6]
df <- GSE72094
BaSurv <- Surv(time = df$OS_time, ## 生存时间
               event = df$OS_status) ## 生存状态
#替换需要展示的gene，构建绘图的model
#model <- coxph( Surv(time, vital_status) ~ gender + age , data =  df )
model <- coxph(BaSurv ~ ENSG00000000003 + ENSG00000000005 , data =  df )
model
#优化森林图
p <- ggforest(model,  #coxph得到的Cox回归结果
         data = df,  #数据集
         main = 'Hazard ratio of LIHC',  #标题
         cpositions = c(0.01, 0.15, 0.35),  #前三列距离,从前往后看
         fontsize = 1, #字体大小
         refLabel = 'reference', #相对变量的数值标签，也可改为1
         noDigits = 3 #保留HR值以及95%CI的小数位数
)
pdf("./forest.pdf",onefile = F,width = 12,height = 6)
print(p)
dev.off()
getwd()
