rm(list=ls())
library(tidyverse)
library(readxl)
library(stringi)
dir.create("./results/2-Pearson Correlation")
genesetname<-c("Apoptosis","Autophagy","Hypoxia","Immuno_Oncology","Immunology")###特殊基因集合


load("./data/train.Rdata")
GSE_exp <- df[,-c(1,2)] %>% t() %>% as.data.frame()

lncRNA<-read.csv('E:/Projects/特殊基因集/lncRNA.csv')###读取lncRNA
lncRNA<-stri_sub(lncRNA$gene_id,1,15)
#ferroptosis_gene<- readxl::read_xlsx('E:/Projects/特殊基因集/FerrDB/ferroptosis-related genes(filter).xlsx')
for(i in 1:length(genesetname)){
i=1
  print(i)
projectname<-genesetname[i]
dir.create(paste0("F:/项目/自己/model for predicting the prognosis/x-Related lncRNA for LGG/results/2-Pearson Correlation/",projectname))
geneset<-read_csv(paste0("E:/Projects/特殊基因集/",projectname,"/",projectname,".csv")) ##去读特殊基因集合


geneset<-geneset[geneset$ENSEMBL %in% rownames(GSE_exp),]
lncRNA_1<-lncRNA[lncRNA %in% rownames(GSE_exp)]
#构建所有mRNA和lncRNA的组合
combination <- expand.grid(geneset$ENSEMBL, lncRNA_1)
#第一列为lncRNA，第二列为mRNA
names(combination)=c(projectname,"lncRNA")

#通过循环来计算所有lncRNA和mRNA之间表达的相关性以及p值
cor_result=apply(combination,1,function(x){
  gene=as.character(x[1])
  lnc=as.character(x[2])
  result=cor.test(as.numeric(GSE_exp[gene,]), as.numeric(GSE_exp[lnc,]))
  score=c(pval=result$p.value,result$estimate)
  return(score)
})
dim(cor_result)

#将lncRNA，mRNA的名字和相关性检验的结果合并起来
result=cbind(combination,t(cor_result))

#挑选p值小于0.05并且相关性大于0.4的lncRNA-mRNA对
index=which(result$pval<0.05 & result$cor>0.6)
result_filter<-result[index,]


save(result,result_filter,file = paste0('F:/项目/自己/model for predicting the prognosis/x-Related lncRNA for LGG/results/2-Pearson Correlation/',projectname,"/",projectname,"_cor.Rdata"))
}

load("./results/2-Pearson Correlation/Apoptosis/Apoptosis_cor.Rdata")
index=which(result$pval<0.05 & result$cor>0.4)
result_filter<-result[index,]
save(result_filter,file = "./results/2-Pearson Correlation/Apoptosis/Apoptosis_cor.Rdata")
