library(ggplot2)
library(scales)
library(tidyverse)
library(png)
library(ggpubr)
setwd("D:\\LUAD\\output\\LUAD_TIDE")
rm(list = ls())
####mytheme####
windowsFonts(myFont = windowsFont("Arial"))
###有x轴
mytheme <- theme_bw() + 
  theme(plot.title=element_text(family="myFont",size=rel(2.2),hjust=0.5),
        axis.title=element_text(family="myFont",size=rel(1.7)),
        axis.text=element_text(family="myFont",size=rel(1.5)),
        panel.grid.major=element_line(color="white"),
        panel.grid.minor=element_line(color="white"),
        panel.border=element_rect(color="black"),
        axis.line=element_line(color="gray",size=1),
        ###设置零轴
        # axis(side=2, pos=0, las=1, lty="dashed"),
        legend.title = element_blank()
  )
# face="bold"


#箱线图

# data <- as.data.frame(data)

data <- read.csv(file = "D:\\LUAD\\data\\TIDE\\TCGA_high_TIDE.csv",header = T)
#data <- TIDE
#data$TIDE <- as.factor(data$TIDE)
#分组变量需要因子化
data$Cluster <- as.factor(data$Cluster)

# data$vriable=factor(data$group, levels=c("High","Low"))
#geom_bar表示画柱状图，position = "dodge"意思为将柱子并列放置，stat是指统计变换；stat='identity'是指不进行统计变换即业务量就是纵。
pdf('D:\\LUAD\\output\\LUAD_TIDE/TIDE.pdf', width = 3, height = 3)
p <- ggplot(data,aes(x = Cluster, y = TIDE))+
  #stat_boxplot(geom="errorbar",width=0.3,size=0.5,position=position_dodge(0.6),color="black")+
  geom_boxplot( position=position_dodge(0.6),
               size=0.5,
               width=0.6,
               fill=c('#E21C21','#3A7CB5'),
               color="black",
               outlier.color = NA,
               outlier.fill = "black",
               outlier.shape = 19,
               outlier.size = 1.5,
               outlier.stroke = 0.5,
               outlier.alpha = 45,
               notch = F,
               notchwidth = 0.5)+
  geom_signif(comparisons=list(c("Cluster1", "Cluster2")),
              y_position = 3, tip_length = 0.04, vjust=0.2) + 
  labs(title="", x="", y="TIDE score")+
  theme(axis.title = element_text(size=18),
        axis.text = element_text(size=14))
p

dev.off()



#p <- ggplot(data,aes(x=data$Patient,y=TIDE,fill=Cluster))
#p + geom_boxplot(data,stat='identity',width = 0.3,position = position_dodge(0.3))+
#  labs(y="TIDE score")+
#  mytheme +
  # geom_text(aes(label=number),position=position_dodge(width = 0.8),size = 12,colour = "black",vjust=0.5)+
#  scale_fill_manual(values=c("#C23531","#2F4554")) +
#  theme(legend.key.size = unit(20, "pt"),legend.text=element_text(size=20),legend.position = c(0.94, 0.92))
# vjust=-0.5 ,hjust=0.5
#dev.off()

