#install.packages("rlang")
#library(ggplot2)
library(scales)
library(tidyverse)
library(utils)

#rforge <- "http://r-forge.r-project.org"
#install.packages("estimate", repos=rforge, dependencies=TRUE)
library("estimate")
load("D:/LUAD/data/TCGA_LUAD.Rdata")
load("D:/LUAD/data/GSE30219.RData")
load("D:/LUAD/data/GSE31210.Rdata")
load("D:/LUAD/data/GSE72094.RData")

write.table(data_symbol_output, 'D:/LUAD/data/GSE72094.txt', quote = FALSE, sep="\t", fileEncoding = 'UTF8', row.names = T)


data <- GSE32019
data <- data[,-c(1,2)]
data_new <- as.data.frame(t(data))
data_new <- cbind("gene_id" = rownames(data_new),data_new)

library(xlsx)
symbol <- read.xlsx2('D:/LUAD/data/gencode.gene.info.v22.xlsx', 1, header=TRUE,colClasses="character")
data_symbol     <- merge(data_new,symbol,by = "gene_id",sort= F)
uid2  = data_symbol$gene_name[duplicated(data_symbol$gene_name)]

data_symbol <- data_symbol %>% filter(!gene_name %in% uid2)
rownames(data_symbol) <- data_symbol$gene_name
data_symbol <- data_symbol[,-c(1,388)]
data_symbol <- as.data.frame(data_symbol)
data_symbol_output <- dplyr::mutate_all(data_symbol,as.numeric)
data_symbol_output <- as.matrix(data_symbol_output)
data_symbol_output[1:4,1:4]

setwd("D:\\LUAD\\output\\ESTIMATE")
write.table(data_symbol_output,"D:\\LUAD\\output\\ESTIMATE\\GSE72094_estimate.txt", quote = FALSE, sep="\t", fileEncoding = 'UTF8', row.names = T)
#data_read <- read.table("D:\\LUAD\\output\\ESTIMATE\\GSE72094_estimate.txt",header = T,sep = "\t",row.names =1)
filterCommonGenes(input.f = "./GSE72094_estimate.txt", 
                  output.f = "./GSE72094_estimate_out.gct",
                  id = 'GeneSymbol')
estimateScore('./GSE72094_estimate_out.gct','./output/GSE72094_estimate_score.gct')
GSE72094_estimate = read.table("./output/GSE72094_estimate_score.gct",skip = 2,header = T)
GSE72094_estimate[1:4,1:4]
write.csv(GSE72094_estimate,"./output/GSE72094_estimate_score.csv")

library(ggplot2)
library(scales)
library(tidyverse)
library(png)
library(ggpubr)

rm(list = ls())
####mytheme####
windowsFonts(myFont = windowsFont("Arial"))
###有x轴
mytheme <- theme_bw() + 
  theme(plot.title=element_text(family="myFont",size=rel(2.2),hjust=0.5),
        axis.title=element_text(family="myFont",size=rel(1.7)),
        axis.text=element_text(family="myFont",size=rel(1.5)),
        panel.grid.major=element_line(color="white"),
        panel.grid.minor=element_line(color="white"),
        panel.border=element_rect(color="black"),
        axis.line=element_line(color="gray",size=1),
        ###设置零轴
        # axis(side=2, pos=0, las=1, lty="dashed"),
        legend.title = element_blank()
  )


#箱线图
library(xlsx)
#TME2 <- read.xlsx2('D:\\LUAD\\output\\LUAD_TME细胞浸润/ESTIMATE.xlsx', 1, header=TRUE,colClasses="character")
TME <- read.csv('D:\\LUAD\\output\\ESTIMATE\\output\\GSE72094_estimate_cluster_score.csv',row.names = 1 )
TME <- as.data.frame(t(TME))
data <- TME[,c(3,5)]
data$ESTIMATEScore
#分组变量需要因子化
data$ESTIMATEScore <- as.numeric(data$ESTIMATEScore)
data$Cluster <- as.factor(data$Cluster)
setwd("D:\\LUAD\\output\\ESTIMATE\\output")
# data$vriable=factor(data$group, levels=c("High","Low"))
#geom_bar表示画柱状图，position = "dodge"意思为将柱子并列放置，stat是指统计变换；stat='identity'是指不进行统计变换即业务量就是纵。
pdf('./GSE72094_ESTIMATE_score.pdf', width = 3, height = 3.2)
p <- ggplot(data,aes(x = Cluster, y = ESTIMATEScore))+
  #stat_boxplot(geom="errorbar",width=0.3,size=0.5,position=position_dodge(0.6),color="black")+
  geom_boxplot( position=position_dodge(0.6),
                size=0.5,
                width=0.6,
                fill=c('#E21C21','#3A7CB5'),
                color="black",
                outlier.color = NA,
                outlier.fill = "black",
                outlier.shape = 19,
                outlier.size = 1.5,
                outlier.stroke = 0.5,
                outlier.alpha = 45,
                notch = F,
                notchwidth = 0.5)+
  geom_signif(comparisons=list(c("Cluster1", "Cluster2")),
              tip_length = 0.04, vjust=0.2) + 
  labs(title="", x="", y="ESTIMATE score")+
  theme(axis.title = element_text(size=18),
        axis.text = element_text(size=14))
p

dev.off()

###1
data <- TME[,c(1,5)]
data$Stromal_score
#分组变量需要因子化
data$StromalScore <- as.numeric(data$StromalScore)
data$Cluster <- as.factor(data$Cluster)

# data$vriable=factor(data$group, levels=c("High","Low"))
#geom_bar表示画柱状图，position = "dodge"意思为将柱子并列放置，stat是指统计变换；stat='identity'是指不进行统计变换即业务量就是纵。
pdf('./GSE72094_Stromal_score.pdf', width = 3, height = 3.2)
p <- ggplot(data,aes(x = Cluster, y = StromalScore))+
  #stat_boxplot(geom="errorbar",width=0.3,size=0.5,position=position_dodge(0.6),color="black")+
  geom_boxplot( position=position_dodge(0.6),
                size=0.5,
                width=0.6,
                fill=c('#E21C21','#3A7CB5'),
                color="black",
                outlier.color = NA,
                outlier.fill = "black",
                outlier.shape = 19,
                outlier.size = 1.5,
                outlier.stroke = 0.5,
                outlier.alpha = 45,
                notch = F,
                notchwidth = 0.5)+
  geom_signif(comparisons=list(c("Cluster1", "Cluster2")),
              tip_length = 0.04, vjust=0.2) + 
  labs(title="", x="", y="Stromal score")+
  theme(axis.title = element_text(size=18),
        axis.text = element_text(size=14))
p

dev.off()

###2
data <- TME[,c(2,5)]
data$ImmuneScore
#分组变量需要因子化
data$ImmuneScore <- as.numeric(data$ImmuneScore)
data$Cluster <- as.factor(data$Cluster)

# data$vriable=factor(data$group, levels=c("High","Low"))
#geom_bar表示画柱状图，position = "dodge"意思为将柱子并列放置，stat是指统计变换；stat='identity'是指不进行统计变换即业务量就是纵。
pdf('./GSE72094_Immune_score.pdf', width = 3, height = 3.2)
p <- ggplot(data,aes(x = Cluster, y = ImmuneScore))+
  #stat_boxplot(geom="errorbar",width=0.3,size=0.5,position=position_dodge(0.6),color="black")+
  geom_boxplot( position=position_dodge(0.6),
                size=0.5,
                width=0.6,
                fill=c('#E21C21','#3A7CB5'),
                color="black",
                outlier.color = NA,
                outlier.fill = "black",
                outlier.shape = 19,
                outlier.size = 1.5,
                outlier.stroke = 0.5,
                outlier.alpha = 45,
                notch = F,
                notchwidth = 0.5)+
  geom_signif(comparisons=list(c("Cluster1", "Cluster2")),
              tip_length = 0.04, vjust=0.2) + 
  labs(title="", x="", y="Immune score")+
  theme(axis.title = element_text(size=18),
        axis.text = element_text(size=14))
p

dev.off()
