library(ggplot2)
library(scales)
library(tidyverse)
library(png)
###画显著性标志
# install.packages("pubr")
# install.packages('pubr', dependencies=TRUE, repos='http://cran.rstudio.com/')
# install.packages('pubr',repos='http://cran.us.r-project.org')
# install.packages("E:/R-4.1.2/ggpubr_0.4.0.zip", repos=NULL)
# if(!require(devtools)) install.packages("devtools")
# devtools::install_github("kassambara/ggpubr")

library(car)
library(ggpubr)
#方差齐性检验，利用car下的Levene检验
library(purrr)

rm(list = ls())
getwd()
setwd("D:/LUAD/output/cluster_IC50")
rm(list = ls())
####mytheme####
windowsFonts(myFont = windowsFont("Arial"))
###有x轴
mytheme <- theme_bw() + 
  theme(plot.title=element_text(family="myFont",size=rel(2.2),hjust=0.5),
        axis.title=element_text(family="myFont",size=rel(1.7)),
        axis.text=element_text(family="myFont",size=rel(1.5)),
        panel.grid.major=element_line(color="white"),
        panel.grid.minor=element_line(color="white"),
        panel.border=element_rect(color="black"),
        axis.line=element_line(color="gray",size=1),
        ###设置零轴
        # axis(side=2, pos=0, las=1, lty="dashed"),
        legend.title = element_blank()
  )


#箱线图
library(xlsx)
IC50 <- read.xlsx2('D:\\LUAD\\data\\IC50_cluster\\LUAD_drug_IC50_select_原版.xlsx', 1, header=TRUE,colClasses="character")
data <- IC50[,c(10,11)]
data$Crizotinib	
#分组变量需要因子化
data[,1] <- as.numeric(data[,1])
data$Cluster <- as.factor(data$Cluster)

# data$vriable=factor(data$group, levels=c("High","Low"))
#geom_bar表示画柱状图，position = "dodge"意思为将柱子并列放置，stat是指统计变换；stat='identity'是指不进行统计变换即业务量就是纵。
pdf('D:\\LUAD\\output\\cluster_IC50/Crizotinib.pdf', width = 3, height = 3)
p <- ggplot(data,aes(x = Cluster, y = Crizotinib	))+
  #stat_boxplot(geom="errorbar",width=0.3,size=0.5,position=position_dodge(0.6),color="black")+
  geom_boxplot( position=position_dodge(0.6),
                size=0.5,
                width=0.6,
                fill=c('#E21C21','#3A7CB5'),
                color="black",
                outlier.color = NA,
                outlier.fill = "black",
                outlier.shape = 19,
                outlier.size = 1.5,
                outlier.stroke = 0.5,
                outlier.alpha = 45,
                notch = F,
                notchwidth = 0.5)+
  geom_signif(comparisons=list(c("Cluster1", "Cluster2")),
              tip_length = 0.04, vjust=0.2) + 
  labs(title="", x="", y="Crizotinib")+
  theme(axis.title = element_text(size=18),
        axis.text = element_text(size=14))
p

dev.off()

