library(ggplot2)
library(scales)
library(tidyverse)
library(png)
library(ggpubr)
setwd("D:\\LUAD\\output\\LUAD_TME细胞浸润")
rm(list = ls())
####mytheme####
windowsFonts(myFont = windowsFont("Arial"))
###有x轴
mytheme <- theme_bw() + 
  theme(plot.title=element_text(family="myFont",size=rel(2.2),hjust=0.5),
        axis.title=element_text(family="myFont",size=rel(1.7)),
        axis.text=element_text(family="myFont",size=rel(1.5)),
        panel.grid.major=element_line(color="white"),
        panel.grid.minor=element_line(color="white"),
        panel.border=element_rect(color="black"),
        axis.line=element_line(color="gray",size=1),
        ###设置零轴
        # axis(side=2, pos=0, las=1, lty="dashed"),
        legend.title = element_blank()
  )


#箱线图
library(xlsx)
TME <- read.xlsx2('D:\\LUAD\\output\\LUAD_TME细胞浸润/ESTIMATE.xlsx', 1, header=TRUE,colClasses="character")
data <- TME[,c(3,4)]
data$ESTIMATE_score
#分组变量需要因子化
data$ESTIMATE_score <- as.numeric(data$ESTIMATE_score)
data$Cluster <- as.factor(data$Cluster)

# data$vriable=factor(data$group, levels=c("High","Low"))
#geom_bar表示画柱状图，position = "dodge"意思为将柱子并列放置，stat是指统计变换；stat='identity'是指不进行统计变换即业务量就是纵。
pdf('D:\\LUAD\\output\\LUAD_TME细胞浸润/ESTIMATE_score.pdf', width = 3, height = 3.2)
p <- ggplot(data,aes(x = Cluster, y = ESTIMATE_score))+
  #stat_boxplot(geom="errorbar",width=0.3,size=0.5,position=position_dodge(0.6),color="black")+
  geom_boxplot( position=position_dodge(0.6),
               size=0.5,
               width=0.6,
               fill=c('#E21C21','#3A7CB5'),
               color="black",
               outlier.color = NA,
               outlier.fill = "black",
               outlier.shape = 19,
               outlier.size = 1.5,
               outlier.stroke = 0.5,
               outlier.alpha = 45,
               notch = F,
               notchwidth = 0.5)+
  geom_signif(comparisons=list(c("Cluster1", "Cluster2")),
              tip_length = 0.04, vjust=0.2) + 
  labs(title="", x="", y="ESTIMATE score")+
  theme(axis.title = element_text(size=18),
        axis.text = element_text(size=14))
p

dev.off()

###1
data <- TME[,c(1,4)]
data$Stromal_score
#分组变量需要因子化
data$Stromal_score <- as.numeric(data$Stromal_score)
data$Cluster <- as.factor(data$Cluster)

# data$vriable=factor(data$group, levels=c("High","Low"))
#geom_bar表示画柱状图，position = "dodge"意思为将柱子并列放置，stat是指统计变换；stat='identity'是指不进行统计变换即业务量就是纵。
pdf('D:\\LUAD\\output\\LUAD_TME细胞浸润/Stromal_score.pdf', width = 3, height = 3.2)
p <- ggplot(data,aes(x = Cluster, y = Stromal_score))+
  #stat_boxplot(geom="errorbar",width=0.3,size=0.5,position=position_dodge(0.6),color="black")+
  geom_boxplot( position=position_dodge(0.6),
                size=0.5,
                width=0.6,
                fill=c('#E21C21','#3A7CB5'),
                color="black",
                outlier.color = NA,
                outlier.fill = "black",
                outlier.shape = 19,
                outlier.size = 1.5,
                outlier.stroke = 0.5,
                outlier.alpha = 45,
                notch = F,
                notchwidth = 0.5)+
  geom_signif(comparisons=list(c("Cluster1", "Cluster2")),
              tip_length = 0.04, vjust=0.2) + 
  labs(title="", x="", y="Stromal score")+
  theme(axis.title = element_text(size=18),
        axis.text = element_text(size=14))
p

dev.off()

###2
data <- TME[,c(2,4)]
data$Immune_score
#分组变量需要因子化
data$Immune_score <- as.numeric(data$Immune_score)
data$Cluster <- as.factor(data$Cluster)

# data$vriable=factor(data$group, levels=c("High","Low"))
#geom_bar表示画柱状图，position = "dodge"意思为将柱子并列放置，stat是指统计变换；stat='identity'是指不进行统计变换即业务量就是纵。
pdf('D:\\LUAD\\output\\LUAD_TME细胞浸润/Immune_score.pdf', width = 3, height = 3.2)
p <- ggplot(data,aes(x = Cluster, y = Immune_score))+
  #stat_boxplot(geom="errorbar",width=0.3,size=0.5,position=position_dodge(0.6),color="black")+
  geom_boxplot( position=position_dodge(0.6),
                size=0.5,
                width=0.6,
                fill=c('#E21C21','#3A7CB5'),
                color="black",
                outlier.color = NA,
                outlier.fill = "black",
                outlier.shape = 19,
                outlier.size = 1.5,
                outlier.stroke = 0.5,
                outlier.alpha = 45,
                notch = F,
                notchwidth = 0.5)+
  geom_signif(comparisons=list(c("Cluster1", "Cluster2")),
              tip_length = 0.04, vjust=0.2) + 
  labs(title="", x="", y="Immune score")+
  theme(axis.title = element_text(size=18),
        axis.text = element_text(size=14))
p

dev.off()


