library(survival)
library(survminer)
rm(list = ls()) ## 清空环境变量
setwd("D:/LUAD/LUAD_M6A")
getwd()
#导入清洗后的数据
load("./data/TCGA_LUAD.Rdata")
TCGA_LUAD[1:7,1:6]
df <- TCGA_LUAD

BaSurv <- Surv(time = df$OS_time, ## 生存时间
               event = df$OS_status) ## 生存状态
#替换需要展示的gene森林图，构建绘图的model
#model <- coxph( Surv(time, vital_status) ~ gender + age , data =  df )  展示性别、年龄森林图
model <- coxph(BaSurv ~ ENSG00000000003 + ENSG00000000005 , data =  df )  #替换列名
model
#优化森林图
p <- ggforest(model,  #coxph得到的Cox回归结果
              data = df,  #数据集
              main = 'Hazard ratio of LIHC',  #标题
              cpositions = c(0.01, 0.15, 0.35),  #前三列距离,从前往后看
              fontsize = 1, #字体大小
              refLabel = 'reference', #相对变量的数值标签，也可改为1
              noDigits = 3 #保留HR值以及95%CI的小数位数
)
pdf("./forest.pdf",onefile = F,width = 12,height = 6)
print(p)
dev.off()
getwd()